#include <REG52.H>

#define XON 17
#define XOFF 19

int cnt = 0;
unsigned long del = 100;

void Timer0_ISR(void) interrupt 1
{
  del--;
  if (del == 0)
   {
    del = 100;
    SBUF = XON;
    ET0 = 0;
   }
}

void SerialISR(void) interrupt 4
{
 if (RI)
  {
   RI = 0;
   cnt++;
   if (cnt == 5)
    {
     SBUF = XOFF;
     while (TI == 0);
     ET0 = 1;
     cnt = 0;
   }
  }
}

void main(void)
{
  SCON = 0x50;
  TMOD = 0x21;
  TH1 = 0x0FD;
  TR1 = 1;
  TI = 0;

  TH0 = 0;
  TL0 = 0;
  TR0 = 1;

  EA = 1;
  ES = 1;
  while(1);
 }
