using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace SerialPort_EXample1
{
  public partial class Form1 : Form
   {
     public String s1;
     public Thread myThread;
     public Form1()
      {
       InitializeComponent();
      }

     private void Form1_Load(object sender, EventArgs e)
      {
        serialPort1.Open();
        myThread = new Thread(this.ThreadProc);
        myThread.Start();
      }

     private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
      {
        s1 = serialPort1.ReadLine();
        textBox1.Text = "RECEIVED: " + s1;
      }

   private void Form1_FormClosing(object sender, FormClosingEventArgs e)
    {
      myThread.Abort();
      serialPort1.Close();
    }
   public void ThreadProc()
    {
     this.serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.serialPort1_DataReceived);
     while (true)
      {
      }
   }
 }
}
