using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace XON_XOFF_Flow_Control_App
{
  public partial class Form1 : Form
   {
    public byte [] buf = {17, 19};
    public Thread myThread;
    public String s1;
    public Form1()
     {
      InitializeComponent();
     }

    private void Form1_Load(object sender, EventArgs e)
     {
      serialPort1.Open();
      myThread = new Thread(this.ThreadProc);
      myThread.Start();
     }

    private void Form1_FormClosing(object sender, FormClosingEventArgs e)
     {
      myThread.Abort();
      serialPort1.Close();
     }
    public void ThreadProc()
     {
      this.serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.serialPort1_DataReceived);
      while (true) { }
    }

    private void xonButton_Click(object sender, EventArgs e)
     {
      serialPort1.Write(buf, 0, 1);
      richTextBox1.AppendText("Transmitting Enabled! ");
     }

    private void xoffButton_Click(object sender, EventArgs e)
      {
       serialPort1.Write(buf, 1, 1);
       richTextBox1.AppendText("Transmitting Disabled!  ");
      }

    private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
     {
      s1 = serialPort1.ReadLine();
      richTextBox1.AppendText(s1);
     }
  }
}
