using System;
using System.ServiceProcess;
using System.Threading;
using System.IO.Ports;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Com4Service
{
   class Class1:ServiceBase
   {
     public static Thread myThread;
     public static SerialPort serialPort1;
     public static EventLog ev;

     private void InitializeComponent()
      {
        // Class1
        //
        this.ServiceName = "Com4Service";
      }
     protected override void OnStart(string[] args)
      {
        base.OnStart(args);
        serialPort1 = new SerialPort("COM4", 9600, Parity.None, 8, StopBits.One);
        serialPort1.Open();
        ev = new EventLog("Application", ".", "Com4Service");
        myThread = new Thread(ThreadProc);
        myThread.Start();
      }
     protected override void OnStop()
      {
       base.OnStop();
       serialPort1.Close();
      }
     public static void ThreadProc()
      {
        serialPort1.DataReceived +=new SerialDataReceivedEventHandler(serialPort1_DataReceived);
        while (true);
    }

     public static void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
      {
       String s = serialPort1.ReadLine();
       ev.WriteEntry("RECEIVED: " + s);
      }
   }
}
