using System;
using System.ServiceProcess;
using System.Diagnostics;
using System.IO;
using System.IO.Ports;
using System.Threading;

using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Com4Service2
{
  class Class1: ServiceBase
  {
   public static Thread myThread;
   public static EventLog ev;
   public static StreamWriter sw;
   public static SerialPort serialPort1;

   private void InitializeComponent()
   {
     //
     // Class1
     //
    this.ServiceName = "Com4Service2";
   }
   protected override void OnStart(string[] args)
   {
    base.OnStart(args);
    ev = new EventLog("Application", ".", "Com4Service2");
    serialPort1 = new SerialPort("COM4", 9600, Parity.None, 8, StopBits.One);
    serialPort1.Open();
    sw = new StreamWriter("c:\\SWLOG.txt", true);
    sw.AutoFlush = true;
    myThread = new Thread(ThreadProc);
    myThread.Start();
   }
   protected override void OnStop()
    {
     base.OnStop();
     sw.Close();
     serialPort1.Close();
    }

   public static void ThreadProc()
   {
    serialPort1.DataReceived +=new SerialDataReceivedEventHandler(serialPort1_DataReceived);
    while (true);
   }
   public static void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
   {
    String s1 = serialPort1.ReadLine();
    sw.WriteLine(s1);
    ev.WriteEntry("DATA RECEIVED From COM4.");
   }
 }
}
