using System;
using System.Net;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TCPServer
{
  class Program
  {
   static void Main(string[] args)
   {
    int bytesRead = 0;
    byte[] buf = new byte[1024];
    String s1;

    IPAddress addr = IPAddress.Parse("127.0.0.1");
    IPEndPoint iep = new IPEndPoint(addr, 5151);
    TcpListener server = new TcpListener(iep);
    server.Start();
    Console.WriteLine("Waiting for data on port 5151...");
    while (true)
     {
      bytesRead = 0;
      TcpClient client = server.AcceptTcpClient();
      NetworkStream stream = client.GetStream();
      bytesRead = stream.Read(buf, 0, buf.Length);
      if (bytesRead > 0)
       {
       s1 = System.Text.ASCIIEncoding.ASCII.GetString(buf, 0, bytesRead);
       Console.WriteLine("DATA RECEIVED: " + s1);
       }
      stream.Close();
      client.Close();
     }
     server.Stop();
    }
  }
}
