using System;
using System.Net;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO.Ports;

namespace TCPClient
{
  class Program
  {
   public static SerialPort serialPort1;
   public static Thread myThread;

   static void Main(string[] args)
    {
      serialPort1 = new SerialPort("COM4", 9600, Parity.None, 8, StopBits.One);
      serialPort1.Open();
      myThread = new Thread(ThreadProc);
      myThread.Start();
 }

  public static void ThreadProc()
   {
    serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
    while (true);
   }

   public static void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
   {
    byte[] buf = new byte[1024];
    String s1 = serialPort1.ReadLine();

    IPAddress addr = IPAddress.Parse("127.0.0.1");
    IPEndPoint iep = new IPEndPoint(addr, 5151);
    TcpClient client = new TcpClient();
    client.Connect(iep);

    NetworkStream stream = client.GetStream();
    int bytesRead = System.Text.ASCIIEncoding.ASCII.GetBytes(s1, 0, s1.Length, buf, 0);
    stream.Write(buf, 0, bytesRead);
    stream.Close();
    client.Close();
   }
 }
}
