unit TCPServer_PAS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, OoMisc, AdPort;

type
  TForm1 = class(TForm)
    TcpServer1: TTcpServer;
    Memo1: TMemo;
    ApdComPort1: TApdComPort;
    procedure TcpServer1Accept(Sender: TObject; ClientSocket: TCustomIpClient);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ApdComPort1TriggerAvail(CP: TObject; Count: Word);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s1: String;
  sbuf: String;
implementation

{$R *.dfm}

procedure TForm1.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
var
 I: Word;
 C: Char;
begin
  for I := 1 to Count do
   begin
    C:= ApdComPort1.GetChar();
    s1:= s1 + C;
    if C = #10 then
     begin
      Memo1.Lines.Append(s1);
      sbuf:= s1;
      s1:= '';
     end;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 TcpServer1.Active:= False;
 ApdComPort1.Open:= False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 TcpServer1.Active:= True;
 ApdComPort1.Open:= True;
end;

procedure TForm1.TcpServer1Accept(Sender: TObject;
  ClientSocket: TCustomIpClient);
begin

  ClientSocket.Sendln (sbuf);
  ClientSocket.Close();
end;

end.
