#include <windows.h>
#include <stdio.h>

void main(void)
{
 HANDLE hCom;
 char *pcComPort = "COM1";
 DCB dcb;

 DWORD bytesRead;
 char buf[128];

 hCom = CreateFile(pcComPort,
                   GENERIC_READ | GENERIC_WRITE,
                   0,
                   NULL,
                   OPEN_EXISTING,
                   0,
                   NULL);
if (hCom == INVALID_HANDLE_VALUE)
 {
  printf("COM1 opening error!\n");
  return;
 }

GetCommState(hCom, &dcb);
printf("COM1 baud rate is %d\n", dcb.BaudRate);
printf("Waiting for data from COM1...\n");
do {
    ReadFile(hCom,
             buf,
             sizeof(buf),
             &bytesRead,
             NULL);
    if (bytesRead > 0)
     {
      buf[bytesRead] = '\0';
      printf(buf);
      printf("\n");
    }
 }while (true);
CloseHandle(hCom);
return;
}

