#include <windows.h>
#include <stdio.h>

char c1;
int counter = 0;

HANDLE hCom;
DWORD bytesRead, bWritten;

BOOL fSuccess;
HANDLE hThread, hThreadW;
DWORD dwParam, dwThreadId;

VOID WINAPI ThreadProc(PVOID* dummy)
 {
  printf("Waiting for data from COM4...\n");
  while (true)
   {
     ReadFile(hCom,
              &c1,
              sizeof(c1),
              &bytesRead,
              NULL);
     if (bytesRead > 0)
      printf("%c", c1);
     counter++;
     if (counter > 7)
      {
       counter = 0;
       EscapeCommFunction(hCom, CLRRTS);
       Sleep(20000);
       EscapeCommFunction(hCom, SETRTS);
       continue;
      }
     WriteFile(hCom,
               &c1,
               sizeof(c1),
               &bWritten,
               0);
  }
}

void main(void)
{
  char *pcComPort = "COM4";
  DCB dcb;

  c1 = 0x0;
  hCom = CreateFile(pcComPort,
                    GENERIC_READ | GENERIC_WRITE,
                    0,
                    NULL,
                    OPEN_EXISTING,
                    0,
                    NULL);
  if (hCom == INVALID_HANDLE_VALUE)
   {
    printf("COM4 opening error!\n");
    return;
   }

  GetCommState(hCom, &dcb);
  dcb.BaudRate = CBR_9600;     // set the baud rate
  dcb.ByteSize = 8;             // data size, xmit, and rcv
  dcb.Parity = NOPARITY;        // no parity bit
  dcb.StopBits = ONESTOPBIT;    // one stop bit
  dcb.fRtsControl = RTS_CONTROL_ENABLE;

  fSuccess = SetCommState(hCom, &dcb);

  if (!fSuccess)
   {
    printf ("SetCommState failed with error %d.\n", GetLastError());
    return;
   }

  printf ("Serial port %s successfully reconfigured.\n", pcComPort);
  GetCommState(hCom, &dcb);
  printf("COM4 baud rate is %d\n", dcb.BaudRate);

  hThread = CreateThread(NULL,
                         0,
                         (LPTHREAD_START_ROUTINE)ThreadProc,
                         &dwParam,
                         0,
                         &dwThreadId);

  while (1);
  CloseHandle(hCom);
  return;
}
