#include <stdio.h>
#include <windows.h>

#define port 8089

BOOL fSuccess;
char *pcComPort = "COM5";
DCB dcb;

HANDLE hThread, hCom;
DWORD dwParam, dwThreadId;

char str[1024];
char com5Buf[4096];
char *pbuf;

char *str_start = "<html><body><h1> ";
char *str_end = " </h1></body></html>";
char buf[4096];
DWORD bytesRead;

VOID WINAPI ThreadProc(LPVOID* dummy)
{
   while (true)
    {
     bytesRead = ReadFile(hCom,
                          pbuf++,
                          1,
                          &bytesRead,
                          NULL);
   }
   CloseHandle(hCom);
}

void main(void)
{
  WSADATA wsd;
  SOCKET sListen, sClient;
  struct sockaddr_in server;
  int bytes;

  if (WSAStartup(MAKEWORD(2,2), &wsd) != 0)
   {
    printf("WSAStartup error: %d\n", GetLastError());
    return;
   }

  pbuf = com5Buf;
  memset(com5Buf, '\0', sizeof(buf));
  server.sin_addr.s_addr = htonl(INADDR_ANY);
  server.sin_family = AF_INET;
  server.sin_port = htons(port);

  sListen = socket(AF_INET, SOCK_STREAM, 0);
  bind(sListen, (struct sockaddr*)&server, sizeof(server));
  listen(sListen, 5);

  hCom = CreateFile(pcComPort,
                    GENERIC_READ | GENERIC_WRITE,
                    0,
                    NULL,
                    OPEN_EXISTING,
                    0,
                    NULL);
  if (hCom == INVALID_HANDLE_VALUE)
      {
       printf("COM5 opening error!\n");
       return;
      }

  GetCommState(hCom, &dcb);
  dcb.BaudRate = CBR_9600;
  dcb.ByteSize = 8;
  dcb.Parity = NOPARITY;
  dcb.StopBits = ONESTOPBIT;

  fSuccess = SetCommState(hCom, &dcb);
  if (!fSuccess)
    {
      printf ("SetCommState failed with error %d.\n", GetLastError());
      return;
    }

  printf ("Serial port %s successfully reconfigured.\n", pcComPort);
  GetCommState(hCom, &dcb);
  printf("COM4 baud rate is %d\n", dcb.BaudRate);
  hThread = CreateThread(NULL,
                         0,
                        (LPTHREAD_START_ROUTINE)ThreadProc,
                         &dwParam,
                         0,
                         &dwThreadId);
  if (hThread == NULL)
   {
    printf("Can't create thread: %d\n", GetLastError());
    closesocket(sListen);
    return;
   }

  printf("WEB-Server waits on port 8089\n");
  while(true)
   {
    sClient = accept(sListen, 0, 0);
    if (sClient != INVALID_SOCKET)
    {
      bytes = recv(sClient, buf, sizeof(buf), 0);
      if (bytes > 0)
       {
        strcpy(str, str_start);
        strcat(str, com5Buf);
        strcat(str, str_end);
        send(sClient, str, strlen(str), 0);
      }
     closesocket(sClient);
     memset(com5Buf, '\0', sizeof(buf));
     pbuf = com5Buf;
    }
  }
  closesocket(sListen);
  return;
}
