using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.IO.Ports;
using System.Threading;
using System.Windows.Forms;

namespace WebServerCS
{
  public partial class Form1 : Form
  {
    public String buf;
    public SerialPort serialPort1;
    public static Thread myThread;
    public static TcpListener server;

    public IPAddress addr;
    public int port = 5151;
    public IPEndPoint iep;
    public int bytesRead;

    public StringBuilder sb;
    public byte[] bytes;
    public Form1()
     {
      InitializeComponent();
     }

    private void Form1_Load(object sender, EventArgs e)
    {
      bytes = new byte[1024];
      serialPort1 = new SerialPort("COM5", 9600, Parity.None, 8, StopBits.One);

      myThread = new Thread(ThreadProc);
      addr = IPAddress.Parse("127.0.0.1");
      iep = new IPEndPoint(addr, port);
      server = new TcpListener(iep);
      myThread.Start();
      serialPort1.Open();
   }

    private void Form1_FormClosing(object sender, FormClosingEventArgs e)
     {
      server.Stop();
      myThread.Abort();
      serialPort1.Close();
    }

    public void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
    {
     buf = serialPort1.ReadLine();
    }
    public void ThreadProc()
     {
      server.Start();
      serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
      while (true)
       {
        String sin, sout;
        TcpClient client = server.AcceptTcpClient();
        NetworkStream stream = client.GetStream();
        bytesRead = stream.Read(bytes, 0, bytes.Length);
        if (bytesRead > 0)
         {
          sin = System.Text.ASCIIEncoding.ASCII.GetString(bytes, 0, bytesRead);
          richTextBox1.AppendText(sin);
          sb = new StringBuilder();
          sb.Append("<html><body></h1>");
          sb.Append(buf); 
          sb.Append("</h1></body></html>");
          sout = sb.ToString(); 
          bytesRead = System.Text.ASCIIEncoding.ASCII.GetBytes(sout, 0, sout.Length, bytes, 0);
          stream.Write(bytes, 0, bytesRead);
         }
       stream.Close();
       client.Close();
     }
  }

    }
}
