#include <REG52.H>

sbit RTS = P1^0;
char Temp;

void INT0_ISR(void) interrupt 0
{
  RTS = 0;
}

void Serial_ISR(void) interrupt 4
{
 if (RI)
  {
   RI = 0;
   Temp = SBUF;
   if (Temp == 0x20)
     RTS = 1;
  }
}

void main(void)
{
  P1 = 0x0;
  RTS = 1;

  SCON = 0x50;
  TMOD = 0x21;
  TH1 = 0x0FD;
  TR1 = 1;
  TI = 1;

  EX0 = 1;
  IT0 = 1;
  ES = 1;
  EA = 1;
  while(1);
 }
