#include <windows.h>
#include <stdio.h>
#include <conio.h>

HANDLE hCom;
char c1;
DWORD bytesRead, bWritten;

BOOL fSuccess;
DWORD dwParam, dwThreadId;

VOID WINAPI ThreadProc(PVOID* dummy)
{
 printf("Waiting for data from COM4...\n");
 while (true)
  {
    ReadFile(hCom,
             &c1,
             sizeof(c1),
             &bytesRead,
             NULL);
   if (bytesRead > 0)
     printf("%c", c1);
   WriteFile(hCom,
             &c1,
             sizeof(c1),
             &bWritten,
             0);
  }
 }

void main(void)
{
  char *pcComPort = "COM4";
  DCB dcb;

  hCom = CreateFile(pcComPort,
                    GENERIC_READ | GENERIC_WRITE,
                    0,
                    NULL,
                    OPEN_EXISTING,
                    0,
                    NULL);
  if (hCom == INVALID_HANDLE_VALUE)
   {
    printf("COM4 opening error!\n");
    return;
   }

  GetCommState(hCom, &dcb);
  dcb.BaudRate = CBR_9600;
  dcb.ByteSize = 8;
  dcb.Parity = NOPARITY;
  dcb.StopBits = ONESTOPBIT;

  fSuccess = SetCommState(hCom, &dcb);
  if (!fSuccess)
   {
    printf ("SetCommState failed with error %d.\n", GetLastError());
    return;
   }

  printf ("Serial port %s successfully reconfigured.\n", pcComPort);
  GetCommState(hCom, &dcb);
  printf("COM4 baud rate is %d\n", dcb.BaudRate);

  hThread = CreateThread(NULL,
                         0,
                        (LPTHREAD_START_ROUTINE)ThreadProc,
                        &dwParam,
                        0,
                        &dwThreadId);

  while (1);
 }
  CloseHandle(hCom);
  return;
}
