#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>

int main (void)
{
 pid_t pid;
 int fd;
 int bytesRead;
 char buf[128];

 fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NONBLOCK);
 if (fd == -1)
  {
   printf("Cannot open port!\n");
   return 1;
   };

 chdir("/root");
 pid = fork();
 if (pid > 0)
  {
   close(fd);
   exit(0);
  }
 setsid();
 printf("Daemon works...\n");
 while (1)
 {
  bytesRead = read(fd, buf, sizeof(buf));
    if (bytesRead > 0)
    {
     buf[bytesRead] = '\0';
     printf("%s", buf);
    };
  }
  close(fd);
  return 0;
 }
